<template>
    <div>
        <div
            class="w-full px-4 py-2 bg-purple-700 text-white relative mb-4"
        >
            <div
                class="font-bold text-2xl my-2 font-mono"
            >
                {{ $helper.fundFormat(balance) }}
            </div>
            <div
                class="capitalize"
            >
                {{ i18n.t(`${String(account).toLowerCase()}_account`) }} {{ $t('balance') }}
            </div>
            <div
                class="absolute inset-y-2 right-2 text-white fill-white"
            >
                <font-awesome-icon
                    icon="fa-solid fa-money-bill"
                    size="4x"
                    class="opacity-50"
                />
            </div>
        </div>
        <custom-card>
            <auto-datatable
                ref="dt"
                model="AccountTransaction"
                :hidden-filters="[
                    {name: 'f-has-account-account_code', value: account}
                ]"
                :headers="[
                    {label: '#', name: 'id'},
                    {label: $t('operation'), name: 'operation', sortable: false},
                    {label: $t('created_by_admin'), name: 'created_by_admin_username', column: 'created_by_admin_id'},
                    {label: $t('verified_by_admin'), name: 'verified_by_admin_username', column: 'verified_by_admin_id'},
                    {label: $t('description'), name: 'transaction_type_explained', column: 'transaction_type'},
                    {label: $t('amount'), name: 'amount'},
                    {label: $t('verified_at'), name: 'verified_at'},
                    {label: $t('created_at'), name: 'created_at'},
                ]"
            >
                <template #action>
                    <create-button
                        :text="$t('create')"
                        @click="adjusting = true"
                    />
                </template>
                <template #default="{records}">
                    <tr
                        v-for="(record, i) in records"
                        :key="i"
                    >
                        <td>{{ i+1 }}</td>
                        <td>
                            <template
                                v-if="record.can_verify"
                            >
                                <a
                                    href="javascript:"
                                    class="text-green-500 fill-white w-8 h-8 mr-2"
                                    @click="promptVerify(true, record)"
                                >
                                    <font-awesome-icon
                                        icon="fa-solid fa-check-square"
                                        size="2x"
                                    />
                                </a>
                                <a
                                    href="javascript:"
                                    class="text-red-500 fill-white w-8 h-8"
                                    @click="promptVerify(false, record)"
                                >
                                    <font-awesome-icon
                                        icon="fa-solid fa-square-xmark"
                                        size="2x"
                                    />
                                </a>
                            </template>
                        </td>
                        <td>{{ record.created_by_admin_username }}</td>
                        <td>{{ record.verified_by_admin_username }}</td>
                        <td>
                            {{ record.transaction_type_explained }}
                            <template
                                v-if="record.remark"
                            >
                                <div
                                    class="w-fit"
                                >
                                    <div class="w-fit bg-red-500 px-2 py-0.5 text-xs text-white rounded-full font-black uppercase">
                                        {{ $t('remark') }}
                                    </div>
                                    <div>
                                        {{ record.remark }}
                                    </div>
                                </div>
                            </template>
                        </td>
                        <td>{{ $helper.fundFormat(record.amount) }}</td>
                        <td>{{ record.verified_at ? $helper.dateTimeFormat(record.verified_at) : '-' }}</td>
                        <td>{{ $helper.dateTimeFormat(record.created_at) }}</td>
                    </tr>
                </template>
            </auto-datatable>
        </custom-card>
        <panel-modal
            v-if="adjusting"
            :has-footer="false"
            @close="adjusting = false"
        >
            <template #body>
                <adjust-form
                    :account="account"
                    @close="onAdjusted"
                />
            </template>
        </panel-modal>
    </div>
</template>
<script setup>
import CreateButton from "~/components/button/create-button.vue";
import CustomCard from "~/components/custom-card.vue";
import AutoDatatable from "~/components/auto-datatable.vue";
import AutoButton from "~/components/button/auto-button.vue";
import axios from "axios";
import {inject, ref, onMounted} from "vue";
import {useI18n} from "vue-i18n";
import PanelModal from "~/components/panel-modal.vue";
import AdjustForm from "~/pages/main/account/adjust-form.vue";
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";
import BigNumber from "bignumber.js";

const balance = ref(0);
const adjusting = ref(false);

const account = ref('STRUCTURED');
const $helper = inject('$helper');
const i18n = useI18n();
const dt = ref();

const fetchBalance = async () => {
    const data = await axios.post('/account/fetch_balance', {
        account_code: account.value
    });

    balance.value = data.account.account_balance;
};

const onAdjusted = async () => {
    await fetchBalance();
    await dt.value.loadData();
    adjusting.value = false;
};

onMounted(async () => {
    await fetchBalance();
});

const promptVerify = (async (verified, model) => {
    let alertMessage;
    if (verified) {
        alertMessage = String(i18n.t('confirm_received_x_payment')).replace(/___X___/i, $helper.fundFormat(new BigNumber(Math.abs(model.amount)).toNumber()));
    } else {
        alertMessage = String(i18n.t('confirm_didnt_receive_x_payment')).replace(/___X___/i, $helper.fundFormat(new BigNumber(Math.abs(model.amount)).toNumber()));
    }
    await $helper.alertConfirm({
        message: alertMessage,
        callback: async (result) => {
            if (result.isConfirmed) {
                await axios.post('/account/verify_transaction', {
                    id: model.id,
                    verified: verified
                });

                await fetchBalance();
                await dt.value.loadData();
            }
        }
    })
});
</script>
